(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.emailNotificationPluginExtension = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

},{}],2:[function(require,module,exports){
/* jshint esnext: true */
const _ = require("lodash");
const DataClass = require("cattura-ui-library/src/lib/dataClass");
const {TextElement} = require("cattura-ui-library/src/lib/processor");

const SettingsForm = require("./plugins/settingsForm");
const settingsForm = require("./settings.pug");

const EmailNotifier = DataClass(function EmailNotifier ()
{
    this.label = this.email;
});

function EmailNotificationExtension (plugin)
{
    plugin.notifierType = "Email";
    plugin.notifierClass = EmailNotifier;
    plugin.options = {
        email: new TextElement({
            default: "",
            label: "Email Address",
            name: "Email Address"
        })
    };

    plugin.settingsForm = SettingsForm(plugin, settingsForm, [
        "host",
        "port",
        "username",
        "password",
        "replyToAddress",
        "replyToName",
        "fromAddress",
        "fromName"
    ], function (parent) {
        this.defaultSenderAddress = "cattura@...";
        this.defaultSenderName = "Cattura";
        
        // treat falsy values as null (so the plugin will fall back to system setting or default)
        // TODO (23 Feb 21): should this be the default behavior of settings form? need to investigate
        this.read = function read ()
        {
            return _(parent.read())
                .mapValues(value => value ? value : null)
                .value();
        };        
    });
    
    return plugin;
}

module.exports = EmailNotificationExtension;

},{"./plugins/settingsForm":undefined,"./settings.pug":3,"cattura-ui-library/src/lib/dataClass":"cattura-ui-library/src/lib/dataClass","cattura-ui-library/src/lib/processor":undefined,"lodash":"lodash"}],3:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Host\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: host\" placeholder=\"localhost\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Port\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"number\" data-bind=\"value: port\" placeholder=\"25\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003C!--.control--\u003E";

pug_html = pug_html + "\n\u003C!--    label Use SSL--\u003E";

pug_html = pug_html + "\n\u003C!--    +checkbox(\"checked: useSsl\")--\u003E";

pug_html = pug_html + "\n\u003C!--.control--\u003E";

pug_html = pug_html + "\n\u003C!--    label Use TLS--\u003E";

pug_html = pug_html + "\n\u003C!--    +checkbox(\"checked: useTls\")--\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Username\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: username\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Password\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"password\" data-bind=\"value: password\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "\"From\" Name\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: fromName, attr: { placeholder: defaultSenderName }\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "\"From\" Address\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: fromAddress, attr: { placeholder: defaultSenderAddress }\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "\"Reply To\" Name\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: replyToName, attr: { placeholder: defaultSenderName }\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "\"Reply To\" Address\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: replyToAddress, attr: { placeholder: defaultSenderAddress }\"\u002F\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}]},{},[2])(2)
});
